include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (equal) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ).
definition eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((axiom_filter_nat_type_O) (return_type)) (return_)).
definition sym_eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) (return_ (O) ) ((filter_nat_type) (return_type) return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((eq_filter_nat_type_O) (return_type)) (return_)).
axiom axiom_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (equal) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)).
definition eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
definition sym_eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (return_ ((S)  n)) ((filter_nat_type) (return_type) return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
axiom nat_ind : \forall (Q:nat -> Prop). (Q (O) ) -> (\forall (x:nat). (Q x) -> Q ((S)  x)) -> \forall (x:nat). Q x.
axiom plus : nat -> nat -> nat.
axiom plus_body : nat -> nat -> nat.
axiom axiom_plus : \forall (n:nat). (equal) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n).
definition eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((axiom_plus) (n)).
definition sym_eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (plus_body)  n) ((plus)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((eq_plus) (n)).
axiom axiom_plus_body_O : (equal) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m).
definition eq_plus_body_O : (leibniz) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m) := ((((equal_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (axiom_plus_body_O).
definition sym_eq_plus_body_O : (leibniz) (nat -> nat) (\lambda m : nat. m) ((plus_body)  (O) ) := ((((sym_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (eq_plus_body_O).
axiom times : nat -> nat -> nat.
axiom times_body : nat -> nat -> nat.
axiom axiom_times : \forall (n:nat). (equal) (nat -> nat) ((times)  n) ((filter_nat_type) (nat -> nat) (times_body)  n).
definition eq_times : \forall (n:nat). (leibniz) (nat -> nat) ((times)  n) ((filter_nat_type) (nat -> nat) (times_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((times)  n)) ((filter_nat_type) (nat -> nat) (times_body)  n)) ((axiom_times) (n)).
definition sym_eq_times : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (times_body)  n) ((times)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((times)  n)) ((filter_nat_type) (nat -> nat) (times_body)  n)) ((eq_times) (n)).
axiom axiom_times_body_O : (equal) (nat -> nat) ((times_body)  (O) ) (\lambda m : nat. (O) ).
definition eq_times_body_O : (leibniz) (nat -> nat) ((times_body)  (O) ) (\lambda m : nat. (O) ) := ((((equal_leibniz) (nat -> nat)) ((times_body)  (O) )) (\lambda m : nat. (O) )) (axiom_times_body_O).
definition sym_eq_times_body_O : (leibniz) (nat -> nat) (\lambda m : nat. (O) ) ((times_body)  (O) ) := ((((sym_leibniz) (nat -> nat)) ((times_body)  (O) )) (\lambda m : nat. (O) )) (eq_times_body_O).
axiom axiom_times_body_S : \forall (n:nat). (equal) (nat -> nat) ((times_body)  ((S)  n)) (\lambda m : nat. (plus)  m ((times)  n m)).
definition eq_times_body_S : \forall (n:nat). (leibniz) (nat -> nat) ((times_body)  ((S)  n)) (\lambda m : nat. (plus)  m ((times)  n m)) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((times_body)  ((S)  n))) (\lambda m : nat. (plus)  m ((times)  n m))) ((axiom_times_body_S) (n)).
definition sym_eq_times_body_S : \forall (n:nat). (leibniz) (nat -> nat) (\lambda m : nat. (plus)  m ((times)  n m)) ((times_body)  ((S)  n)) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((times_body)  ((S)  n))) (\lambda m : nat. (plus)  m ((times)  n m))) ((eq_times_body_S) (n)).
definition plus_O_n : \forall (n:nat). (eq) (nat) n ((plus)  (O)  n) := \lambda n : nat. (((sym_eq_plus) ((O) )) (\lambda y : nat -> nat. (eq) (nat) n (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((plus_body) )) (\lambda y : nat -> nat. (eq) (nat) n (y n))) (((sym_eq_plus_body_O) (\lambda y : nat -> nat. (eq) (nat) n (y n))) (((refl) (nat)) (n)))).
definition times_Sn_m : \forall (n:nat). \forall (m:nat). (eq) (nat) ((plus)  m ((times)  n m)) ((times)  ((S)  n) m) := \lambda n : nat. \lambda m : nat. (((sym_eq_times) ((S)  n)) (\lambda y : nat -> nat. (eq) (nat) ((plus)  m ((times)  n m)) (y m))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((times_body) )) (n)) (\lambda y : nat -> nat. (eq) (nat) ((plus)  m ((times)  n m)) (y m))) ((((sym_eq_times_body_S) (n)) (\lambda y : nat -> nat. (eq) (nat) ((plus)  m ((times)  n m)) (y m))) (((refl) (nat)) ((plus)  m ((times)  n m))))).
definition times_O_n : \forall (n:nat). (eq) (nat) (O)  ((times)  (O)  n) := \lambda n : nat. (((sym_eq_times) ((O) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((times_body) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y n))) (((sym_eq_times_body_O) (\lambda y : nat -> nat. (eq) (nat) (O)  (y n))) (((refl) (nat)) ((O) )))).
definition times_n_O : \forall (n:nat). (eq) (nat) (O)  ((times)  n (O) ) := \lambda n : nat. ((((nat_ind) (\lambda j_x_365 : nat. (eq) (nat) (O)  ((times)  j_x_365 (O) ))) (((((((rewrite_l) (nat)) ((O) )) (\lambda j__ : nat. (eq) (nat) (O)  j__)) (((refl) (nat)) ((O) ))) ((times)  (O)  (O) )) ((times_O_n) ((O) )))) (\lambda x_366 : nat. \lambda j_x_368 : (eq) (nat) (O)  ((times)  x_366 (O) ). (((((((rewrite_l) (nat)) ((plus)  (O)  ((times)  x_366 (O) ))) (\lambda j__ : nat. (eq) (nat) (O)  j__)) (((((((rewrite_l) (nat)) ((O) )) (\lambda j__ : nat. (eq) (nat) (O)  ((plus)  (O)  j__))) (((((((rewrite_l) (nat)) ((O) )) (\lambda j__ : nat. (eq) (nat) (O)  j__)) (((refl) (nat)) ((O) ))) ((plus)  (O)  (O) )) ((plus_O_n) ((O) )))) ((times)  x_366 (O) )) (j_x_368))) ((times)  ((S)  x_366) (O) )) (((times_Sn_m) (x_366)) ((O) ))))) (n).
